/* xxvdasmt.p Vendor Auto Schedule E-mail address maintenance */
        {mfdtitle.i "xx.01"}
        
        define variable vEmail        as character                      no-undo.
        
        define frame fvend
          skip(1)
          vd_addr   colon 20  
          vd_sort   no-label skip(1)
          vEmail    colon 20 label "Auto Schedule Email"  format "x(55)"
          skip(1)
          with side-labels width 80 1 down .
        
/* SCROLL TRIGGERS*/
on F8, cursor-up of vd_addr in frame fvend do:
        find prev vd_mstr where vd_domain = global_domain and vd_addr < input vd_addr no-lock no-error.
        if avail vd_mstr then do:
          display vd_addr vd_sort vd__chr04 @ vEmail with frame fvend.
        end.
        else do:
          hide message no-pause.
          {mfmsg.i 21 2} /* Beg of file*/
          bell.
        end.
end.
        
on F9, cursor-down of vd_addr in frame fvend do:
        find next vd_mstr where vd_domain = global_domain and vd_addr > input vd_addr no-lock no-error.
        if avail vd_mstr then do:
          display vd_addr vd_sort vd__chr04 @ vEmail with frame fvend.
        end.
        else do:
          hide message no-pause.
          {mfmsg.i 20 2} /* End of file*/
          bell.
        end.
end.
        define variable recVD         as recid                          no-undo.
        
        mainloop:
        repeat with frame fvend :
        
          prompt-for vd_addr.
          vEmail = "".

          recVD = -1.
          for first vd_mstr no-lock
            where vd_domain = global_domain
              and vd_addr   = input vd_addr:
            recVD = recid(vd_mstr).
          end.
          release vd_mstr.
          
          DO TRANSACTION:
            find vd_mstr where recid(vd_mstr) = recVD exclusive no-wait no-error.
            if locked(vd_mstr) then do:
              message "Locked try later".
              pause 2.
              next mainloop.
            end.
        
            if not available(vd_mstr) then do:
              message "Vendor " (if input vd_addr = "" then "BLANK" else input vd_addr)
                " is not in the system. Please re-enter." view-as alert-box ERROR.
              next mainloop.
            end.
            find current vd_mstr share-lock.
          END.  /*TRANSACTION*/

          display vd_addr vd_sort vd__chr04 @ vEmail with frame fvend.      
              
          vEmail = vd__chr04.
          update vEmail with frame fvend.

          DO TRANSACTION:
            find vd_mstr where recid(vd_mstr) = recVD exclusive no-wait no-error.
            if locked(vd_mstr) then do:
              message "Locked try later".
              pause 2.
              next mainloop.
            end.
        
            if not available(vd_mstr) then do:
              message "Vendor " (if input vd_addr = "" then "BLANK" else input vd_addr)
                " is not in the system. Please re-enter." view-as alert-box ERROR.
              next mainloop.
            end.
            assign vd__chr04 = vEmail.
            release vd_mstr.
          END.  /*TRANSACTION.*/
        end.
