/******************************************************************************/
/*                                                                            */
/*  xxrsrp05d.p           Shipping Scheduled Control file                     */
/*                          Print zero lines flag look up for LBox            */
/*                                                                            */
/*  MC01 05/21/13 MCE     Created                                             */
/*                                                                            */
/******************************************************************************/
/* rsrp05d.p Shipping Scheduled Control file Print zero lines flag look up    */
/* Copyright 1986-2004 QAD Inc., Carpinteria, CA, USA.                        */
/* All rights reserved worldwide.  This is an unpublished work.               */
/* $Revision: 1.8 $                                                           */
/*V8:ConvertMode=Report                                                       */
/* REVISION: 9.0    CREATED: 11/03/98           BY: *K1QZ* Pat McCormick      */
/* REVISION: 9.0   MODIFIED: 03/13/99           BY: *M0BD* Alfred Tan         */
/* REVISION: 9.1   MODIFIED: 08/12/00           BY: *N0KP* Mark Brown         */
/* Revision: 1.6  BY: Jean Miller DATE: 04/16/02 ECO: *P05H* */
/* $Revision: 1.8 $ BY: Paul Donnelly (SB) DATE: 06/28/03 ECO: *Q00L* */
/*-Revision end---------------------------------------------------------------*/

/******************************************************************************/
/* All patch markers and commented out code have been removed from the source */
/* code below. For all future modifications to this file, any code which is   */
/* no longer required should be deleted and no in-line patch markers should   */
/* be added.  The ECO marker should only be included in the Revision History. */
/******************************************************************************/

/* -----  W A R N I N G  -----  W A R N I N G  -----  W A R N I N G  -----  */
/*                                                                          */
/*         THIS PROGRAM IS A BOLT-ON TO STANDARD PRODUCT MFG/PRO.           */
/* ANY CHANGES TO THIS PROGRAM MUST BE PLACED ON A SEPARATE ECO THAN        */
/* STANDARD PRODUCT CHANGES.  FAILURE TO DO THIS CAUSES THE BOLT-ON CODE TO */
/* BE COMBINED WITH STANDARD PRODUCT AND RESULTS IN PATCH DELIVERY FAILURES.*/
/*                                                                          */
/* -----  W A R N I N G  -----  W A R N I N G  -----  W A R N I N G  -----  */

/* PARAMETERS */
{mgdomain.i}

define output parameter wk_print_zero_lines_sw like mfc_logical.

find first rsc_ctrl  where rsc_ctrl.rsc_domain = global_domain no-lock no-error.

wk_print_zero_lines_sw = rsc_zero_req.

if error-status:error then wk_print_zero_lines_sw = yes.
